## gli 0.8.2.0+ds1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6 FATAL_ERROR)
cmake_policy(VERSION 2.6)
if (NOT CMAKE_VERSION VERSION_LESS "3.1")
	cmake_policy(SET CMP0054 NEW)
endif()

project(gli)
set(GLI_VERSION "0.8.1")

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

enable_testing()

add_definitions(-D_CRT_SECURE_NO_WARNINGS)
add_definitions(-DSOURCE_DIR="${CMAKE_CURRENT_SOURCE_DIR}")
include_directories(".")

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
	# To generate .asm files: /FAs
	add_definitions(/Za)
endif()

if(("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang") OR ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU") OR (("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel") AND UNIX))
	set(CMAKE_CXX_FLAGS "-std=c++0x")
	add_definitions(-Wall)
endif()

################################
# Add source files

file(GLOB ROOT_SOURCE ./gli/*.cpp)
file(GLOB ROOT_INLINE ./gli/*.inl)
file(GLOB ROOT_HEADER ./gli/*.hpp)
file(GLOB ROOT_TEXT ./*.txt)
file(GLOB ROOT_MD ../*.md)
file(GLOB ROOT_KMG ./doc/spec/*.html)

file(GLOB_RECURSE CORE_SOURCE ./gli/core/*.cpp)
file(GLOB_RECURSE CORE_INLINE ./gli/core/*.inl)
file(GLOB_RECURSE CORE_HEADER ./gli/core/*.hpp)

file(GLOB_RECURSE GTX_SOURCE ./gli/gtx/*.cpp)
file(GLOB_RECURSE GTX_INLINE ./gli/gtx/*.inl)
file(GLOB_RECURSE GTX_HEADER ./gli/gtx/*.hpp)

source_group("KMG Spec" FILES  ${ROOT_KMG})
source_group("Text Files" FILES ${ROOT_TEXT} ${ROOT_MD})
source_group("Core Files" FILES ${CORE_SOURCE})
source_group("Core Files" FILES ${CORE_INLINE})
source_group("Core Files" FILES ${CORE_HEADER})
source_group("GTX Files" FILES ${GTX_SOURCE})
source_group("GTX Files" FILES ${GTX_INLINE})
source_group("GTX Files" FILES ${GTX_HEADER})

################################
# Add package

macro(addExternalPackageGTC NAME DIRECTORY)
	set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/external/${DIRECTORY}/util)
	set(${NAME}_PACKAGE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/external/${DIRECTORY})

	find_package(${NAME})
	if(NOT ${NAME}_FOUND)
		message("ERROR: ${NAME} not found")
	endif(NOT ${NAME}_FOUND)
endmacro(addExternalPackageGTC)

################################
# Add GLM 

set(GLM_DIRECTORY glm)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/external/${GLM_DIRECTORY})

################################
# Add subdirectory

add_subdirectory(gli)
add_subdirectory(test)
#add_subdirectory(doc)

################################
# Add installer


set(GLI_INSTALL_CONFIGDIR "${CMAKE_INSTALL_LIBDIR}/cmake/gli")
install(DIRECTORY gli DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

write_basic_package_version_file(
	"${CMAKE_CURRENT_BINARY_DIR}/gliVersion.cmake"
	VERSION ${GLI_VERSION}
	COMPATIBILITY AnyNewerVersion
)

# build tree package config
configure_file(
	cmake/gliBuildConfig.cmake.in
	gliConfig.cmake
	@ONLY
)

# install tree package config
configure_package_config_file(
	cmake/gliConfig.cmake.in
	${GLI_INSTALL_CONFIGDIR}/gliConfig.cmake
	INSTALL_DESTINATION ${GLI_INSTALL_CONFIGDIR}
	PATH_VARS CMAKE_INSTALL_INCLUDEDIR
	NO_CHECK_REQUIRED_COMPONENTS_MACRO
)

install(
	FILES
		"${CMAKE_CURRENT_BINARY_DIR}/${GLI_INSTALL_CONFIGDIR}/gliConfig.cmake"
		"${CMAKE_CURRENT_BINARY_DIR}/gliVersion.cmake"
	DESTINATION ${GLI_INSTALL_CONFIGDIR}
)

if (NOT CMAKE_VERSION VERSION_LESS "3.0")
	add_library(gli INTERFACE)
	target_include_directories(gli INTERFACE
		$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
		$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
	)
	install(TARGETS gli EXPORT gliTargets)

	export(
		EXPORT gliTargets
		FILE "${CMAKE_CURRENT_BINARY_DIR}/gliTargets.cmake"
	)

	install(
		EXPORT gliTargets FILE gliTargets.cmake
		DESTINATION ${GLI_INSTALL_CONFIGDIR}
	)
endif()

export(PACKAGE gli)

=== test/CMakeLists.txt ===
function(glmCreateTestGTC NAME)
	file(GLOB_RECURSE CORE_SOURCE ../gli/core/*.cpp)
	file(GLOB_RECURSE CORE_INLINE ../gli/core/*.inl)
	file(GLOB_RECURSE CORE_HEADER ../gli/core/*.hpp)

	file(GLOB_RECURSE GTX_SOURCE ../gli/gtx/*.cpp)
	file(GLOB_RECURSE GTX_INLINE ../gli/gtx/*.inl)
	file(GLOB_RECURSE GTX_HEADER ../gli/gtx/*.hpp)

	source_group("KMG Spec" FILES  ${ROOT_KMG})
	source_group("Text Files" FILES ${ROOT_TEXT} ${ROOT_MD})
	source_group("Core Files" FILES ${CORE_SOURCE})
	source_group("Core Files" FILES ${CORE_INLINE})
	source_group("Core Files" FILES ${CORE_HEADER})
	source_group("GTX Files" FILES ${GTX_SOURCE})
	source_group("GTX Files" FILES ${GTX_INLINE})
	source_group("GTX Files" FILES ${GTX_HEADER})

	set(SAMPLE_NAME test-${NAME})
	add_executable(${SAMPLE_NAME} ${NAME}.cpp)
	add_test( 
		NAME ${SAMPLE_NAME} ${GTX_INLINE} ${GTX_HEADER} ${CORE_INLINE} ${CORE_HEADER}
		COMMAND $<TARGET_FILE:${SAMPLE_NAME}> )
endfunction()

add_subdirectory(bug)
add_subdirectory(core)

=== test/bug/CMakeLists.txt ===
glmCreateTestGTC(bug)

=== test/core/CMakeLists.txt ===
glmCreateTestGTC(core)
glmCreateTestGTC(core_addressing)
glmCreateTestGTC(core_comparison)
glmCreateTestGTC(convert_sampler1d)
glmCreateTestGTC(convert_sampler1d_array)
glmCreateTestGTC(convert_sampler2d)
glmCreateTestGTC(convert_sampler2d_array)
glmCreateTestGTC(convert_sampler3d)
glmCreateTestGTC(convert_sampler_cube)
glmCreateTestGTC(convert_sampler_cube_array)
glmCreateTestGTC(core_convert)
glmCreateTestGTC(core_convert_access)
glmCreateTestGTC(core_filter_1d)
glmCreateTestGTC(core_filter_2d)
glmCreateTestGTC(core_filter_3d)
glmCreateTestGTC(core_format)
glmCreateTestGTC(core_sample)
glmCreateTestGTC(core_storage)
glmCreateTestGTC(core_image)
glmCreateTestGTC(core_load)
glmCreateTestGTC(core_load_gen_1d)
glmCreateTestGTC(core_load_gen_1d_array)
glmCreateTestGTC(core_load_gen_2d)
glmCreateTestGTC(core_load_gen_2d_array)
glmCreateTestGTC(core_load_gen_3d)
glmCreateTestGTC(core_load_gen_cube)
glmCreateTestGTC(core_load_gen_cube_array)
glmCreateTestGTC(core_load_gen_rect)
glmCreateTestGTC(core_load_dds)
glmCreateTestGTC(core_load_ktx)
glmCreateTestGTC(core_sampler_clear)
glmCreateTestGTC(core_sampler_texel)
glmCreateTestGTC(core_sampler_wrap)
glmCreateTestGTC(core_save)
glmCreateTestGTC(gl)
glmCreateTestGTC(texture_lod_sampler1d)
glmCreateTestGTC(texture_lod_sampler1d_array)
glmCreateTestGTC(texture_lod_sampler2d)
glmCreateTestGTC(texture_lod_sampler2d_array)
glmCreateTestGTC(texture_lod_sampler3d)
glmCreateTestGTC(texture_lod_sampler_cube)
glmCreateTestGTC(texture_lod_sampler_cube_array)
glmCreateTestGTC(generate_mipmaps_sampler1d)
glmCreateTestGTC(generate_mipmaps_sampler1d_array)
glmCreateTestGTC(generate_mipmaps_sampler2d)
glmCreateTestGTC(generate_mipmaps_sampler2d_array)
glmCreateTestGTC(generate_mipmaps_sampler3d)
glmCreateTestGTC(generate_mipmaps_sampler_cube)
glmCreateTestGTC(generate_mipmaps_sampler_cube_array)
glmCreateTestGTC(core_swizzle)
glmCreateTestGTC(core_texture)
glmCreateTestGTC(core_texture_1d)
glmCreateTestGTC(core_texture_1d_array)
glmCreateTestGTC(core_texture_2d)
glmCreateTestGTC(core_texture_2d_array)
glmCreateTestGTC(core_texture_3d)
glmCreateTestGTC(core_texture_cube)
glmCreateTestGTC(core_texture_cube_array)
glmCreateTestGTC(core_clear)
glmCreateTestGTC(core_fetch)
glmCreateTestGTC(core_flip)
glmCreateTestGTC(reduce)
glmCreateTestGTC(test_copy)
glmCreateTestGTC(test_copy_sub)
glmCreateTestGTC(test_duplicate)
glmCreateTestGTC(test_view)
glmCreateTestGTC(test_size)
glmCreateTestGTC(test_make_texture)
glmCreateTestGTC(transform)

## gli 0.8.2.0%2Bds1

=== debian/changelog ===
gli (0.8.2.0+ds1-2) unstable; urgency=medium

  * Fix CMake detection for all architectures
    - New patch Fix-CMake-package-version-file.patch (Closes: #851050)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 11 Jan 2017 23:44:10 +0000

gli (0.8.2.0+ds1-1) unstable; urgency=medium

  * New upstream version 0.8.2.0+ds1
  * Update patch queue.
    - Drop patch Discard-readme-from-docs.patch, applied upstream.
    - New patch Fix-path-to-project-logo.patch.
    - New patch Fix-project-version.patch.
  * Update packaging according to new doxygen setup.
  * Drop changelogs install override, no longer applicable.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 16 Nov 2016 15:55:50 +0000

gli (0.8.1.1+ds1-2) unstable; urgency=medium

  * d/t/control: add missing dependency on a c++ compiler.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 11 Oct 2016 07:47:40 +0100

gli (0.8.1.1+ds1-1) unstable; urgency=low

  * Initial release. (Closes: # 838990)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 04 Oct 2016 10:30:34 +0100

=== debian/control ===
Source: gli
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: libs
Priority: optional
Build-Depends: cmake,
               debhelper (>= 10),
               doxygen,
               libglm-dev (>= 0.9.8)
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/gli.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/gli.git
Homepage: http://gli.g-truc.net/

Package: libgli-dev
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: ${misc:Depends}
Suggests: libgli-doc
Description: C++ image library for graphics software
 OpenGL Image (GLI) is a header only C++ image library for graphics software.
 .
 GLI provides classes and functions to load image files (KTX and DDS),
 facilitate graphics APIs texture creation, compare textures, access texture
 texels, sample textures, convert textures, generate mipmaps, etc.
 .
 This library works perfectly with OpenGL or Vulkan but it also ensures
 interoperability with other third party libraries and SDK. It is a good
 candidate for software rendering (raytracing / rasterisation), image
 processing, image based software testing or any development context that
 requires a simple and convenient image library.
 .
 This package provides the header-only library.

Package: libgli-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: documentation for the OpenGL Image (GLI) library
 OpenGL Image (GLI) is a header only C++ image library for graphics software.
 .
 GLI provides classes and functions to load image files (KTX and DDS),
 facilitate graphics APIs texture creation, compare textures, access texture
 texels, sample textures, convert textures, generate mipmaps, etc.
 .
 This library works perfectly with OpenGL or Vulkan but it also ensures
 interoperability with other third party libraries and SDK. It is a good
 candidate for software rendering (raytracing / rasterisation), image
 processing, image based software testing or any development context that
 requires a simple and convenient image library.
 .
 This package provides the documentation.

=== debian/tests/control ===
Tests: gli-tests
Depends: @, cmake (>= 3.0), g++ | c++-compiler, libglm-dev (>= 0.9.8)
Restrictions: allow-stderr

## gli 0.8.2.0+ds1

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_LIBDIR="lib"

override_dh_auto_build:
	dh_auto_build
	(cd doc && doxygen man.doxy)

override_dh_installdocs:
	dh_installdocs
	dh_doxygen

=== debian/watch ===
version=3
opts=repacksuffix=+ds1,\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\d+)?$//,\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/gli-$1\.tar\.gz/ \
https://github.com/g-truc/gli/tags .*/v?(\d\S*)\.tar\.gz
